<?

/**
   Classe de manipulação da tabela automovel, que na verdade guarda
   outros tipos de veículos
*/
class Automovel{
   private $link;
   function Automovel($link){
      $this->link = $link;      
   }
   public function lista($limit1, $limit2){
      return($this->link->query("SELECT 
Automovel.*,Marca.nomeMarca,Combustivel.nomeCombustivel,Cliente.nomeCliente,Cor.nomeCor,Modelo.nomeModelo FROM ".$this->link->getDb().".Automovel, ".$this->link->getDb().".Combustivel, ".$this->link->getDb().".Cliente, ".$this->link->getDb().".Cor, ".$this->link->getDb().".Modelo, ".$this->link->getDb().".Marca WHERE Automovel.Combustivel_idCombustivel = Combustivel.idCombustivel AND Automovel.Cliente_idCliente = Cliente.idCliente AND Automovel.Cor_idCor = Cor.idCor AND Automovel.Modelo_idModelo = Modelo.idModelo AND Marca.idMarca = Modelo.Marca_idMarca LIMIT $limit1, $limit2"));
   }
   
   public function listaPorCliente($limit1, $limit2, $idCliente){
      return($this->link->query("SELECT 
Automovel.*,Marca.nomeMarca,Combustivel.nomeCombustivel,Cliente.nomeCliente,Cor.nomeCor,Modelo.nomeModelo FROM ".$this->link->getDb().".Automovel, ".$this->link->getDb().".Combustivel, ".$this->link->getDb().".Cliente, ".$this->link->getDb().".Cor, ".$this->link->getDb().".Modelo, ".$this->link->getDb().".Marca WHERE Automovel.Combustivel_idCombustivel = Combustivel.idCombustivel AND Automovel.Cliente_idCliente = Cliente.idCliente AND Automovel.Cor_idCor = Cor.idCor AND Automovel.Modelo_idModelo = Modelo.idModelo AND Marca.idMarca = Modelo.Marca_idMarca AND Cliente_idCliente=".$idCliente." LIMIT $limit1, $limit2"));
   }
   
   public function recupera($idAutomovel){
      $automovel = ($this->link->query("SELECT Automovel.*,Marca.nomeMarca,Combustivel.nomeCombustivel,Cliente.telefone,Cliente.nomeCliente,Cor.nomeCor,Modelo.nomeModelo FROM ".$this->link->getDb().".Automovel, ".$this->link->getDb().".Combustivel, ".$this->link->getDb().".Cliente, ".$this->link->getDb().".Cor, ".$this->link->getDb().".Modelo, ".$this->link->getDb().".Marca WHERE Automovel.Combustivel_idCombustivel = Combustivel.idCombustivel AND Automovel.Cliente_idCliente = Cliente.idCliente AND Automovel.Cor_idCor = Cor.idCor AND Automovel.Modelo_idModelo = Modelo.idModelo AND Marca.idMarca = Modelo.Marca_idMarca AND idAutomovel=".$idAutomovel));
      return $automovel[$idAutomovel];
   }
   
   public function recuperaPorCliente($idAutomovel, $idCliente){
      $automovel = ($this->link->query("SELECT Automovel.*,Marca.nomeMarca,Combustivel.nomeCombustivel,Cliente.nomeCliente,Cor.nomeCor,Modelo.nomeModelo FROM ".$this->link->getDb().".Automovel, ".$this->link->getDb().".Combustivel, ".$this->link->getDb().".Cliente, ".$this->link->getDb().".Cor, ".$this->link->getDb().".Modelo, ".$this->link->getDb().".Marca WHERE Automovel.Combustivel_idCombustivel = Combustivel.idCombustivel AND Automovel.Cliente_idCliente = Cliente.idCliente AND Automovel.Cor_idCor = Cor.idCor AND Automovel.Modelo_idModelo = Modelo.idModelo AND Marca.idMarca = Modelo.Marca_idMarca AND Cliente_idCliente = ".$idCliente." AND idAutomovel=".$idAutomovel));
      return $automovel[$idAutomovel];
   }
   
   public function porCor($idCor){
      return($this->link->query("SELECT * FROM ".$this->link->getDb().".Automovel WHERE Cor_idCor=".$idCor));
   }
   public function porCombustivel($idCombustivel){
      return($this->link->query("SELECT * FROM ".$this->link->getDb().".Automovel WHERE Combustivel_idCombustivel=".$idCombustivel));
   }
   public function porModelo($idModelo){
      return($this->link->query("SELECT * FROM ".$this->link->getDb().".Automovel WHERE Modelo_idModelo=".$idModelo));
   }
   public function porAnoFabricacao($dataMin, $dataMax){
      return($this->link->query("SELECT * FROM ".$this->link->getDb().".Automovel WHERE anoFabricacao <= ".$dataMax." AND anoFabricacao >= ".$dataMin));
   }
   public function porAnoModelo($dataMin, $dataMax){
      return($this->link->query("SELECT * FROM ".$this->link->getDb().".Automovel WHERE anoModelo <= ".$dataMax." AND anoModelo >= ".$dataMin));
   }
   public function porQuilometragem($kmMax){
      return($this->link->query("SELECT * FROM ".$this->link->getDb().".Automovel WHERE quilometragem <= ".$kmMax));
   }
   public function insere($idCombustivel, $idCliente, $idCor, $idModelo, $anoFabricacao, $anoModelo, $versao, $motor, $portas, $preco, $quilometragem, $placa, $descricao,$urlFoto){
      return $this->link->update("INSERT INTO ".$this->link->getDb().".Automovel(Combustivel_idCombustivel, Cliente_idCliente, Cor_idCor, Modelo_idModelo, anoFabricacao, anoModelo, versao, motor, portas, preco, quilometragem, placa, descricao,url_foto) VALUES('".$idCombustivel."', '".$idCliente."', '".$idCor."', '".$idModelo."', '".$anoFabricacao."', '".$anoModelo."', '".$versao."', '".$motor."', '".$portas."', '".$preco."', '".$quilometragem."', '".$placa."', '".$descricao."', '".$urlFoto."')");
   }
   
   public function remove($idAutomovel){
      return $this->link->update("DELETE FROM ".$this->link->getDb().".Automovel WHERE idAutomovel=".$idAutomovel);
   }
   
   public function removePorCliente($idAutomovel, $idCliente){
      return $this->link->update("DELETE FROM ".$this->link->getDb().".Automovel WHERE idAutomovel=".$idAutomovel." AND Cliente_idCliente = ".$idCliente);
   }
   
   //edita >> passar "" no campo que não quiser alterar
   public function edita($idAutomovel, $idCombustivel, $idCor, $idModelo, $anoFabricacao, $anoModelo, $versao, $motor, $portas, $preco, $quilometragem, $placa, $descricao){
      $ret = true;
      if($idCombustivel!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET Combustivel_idCombustivel=".$idCombustivel." WHERE idAutomovel=".$idAutomovel) && $ret;
      if($idCor!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET Cor_idCor=".$idCor." WHERE idAutomovel=".$idAutomovel)  && $ret;
      if($idModelo!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET Modelo_idModelo=".$idModelo." WHERE idAutomovel=".$idAutomovel) && $ret;
      if($anoFabricacao!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET anoFabricacao='".$anoFabricacao."' WHERE idAutomovel=".$idAutomovel)&& $ret;
      if($anoModelo!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET anoModelo='".$anoModelo."' WHERE idAutomovel=".$idAutomovel)&& $ret;
      if($versao!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET versao='".$versao."' WHERE idAutomovel=".$idAutomovel)&& $ret;
      if($motor!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET motor='".$motor."' WHERE idAutomovel=".$idAutomovel)&& $ret;
      if($portas!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET portas=".$portas." WHERE idAutomovel=".$idAutomovel)&& $ret;
      if($preco!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET preco=".$preco." WHERE idAutomovel=".$idAutomovel)&& $ret;
      if($quilometragem!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET quilometragem=".$quilometragem." WHERE idAutomovel=".$idAutomovel)&& $ret;
      if($placa!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET placa='".$placa."' WHERE idAutomovel=".$idAutomovel)&& $ret;
      if($descricao!="")
         $ret = $this->link->update("UPDATE ".$this->link->getDb().".Automovel SET descricao='".$descricao."' WHERE idAutomovel=".$idAutomovel)&& $ret;
      return $ret;
   }      
   
   /**
      Conta a quantidade total de tuplas da tabela
   */
   public function conta(){
      if ($ret = $this->link->query("SELECT count(*) as total FROM ".$this->link->getDb().".Automovel")){
         foreach($ret as $retorno)
            return $retorno['total'];
      }else {
         return false;
      }
   }
   
   /**
      Conta a quantidade de tuplas da tabela, pertencentes a determinado cliente
   */
   public function contaPorCliente($idCliente){
      if ($ret = $this->link->query("SELECT count(*) as total FROM ".$this->link->getDb().".Automovel WHERE Automovel.Cliente_idCliente=".$idCliente)){
         foreach($ret as $retorno)
            return $retorno['total'];
      }else {
         return false;
      }
   }
}

?>
