<?


/**
   Classe de manipulação das views utilizadas para consultas
   por usuários em geral
*/
class Publico{
   private $link;
   function Publico($link){
      $this->link = $link;      
   }
//Faixa de Ano e Modelonome
//Modelo preço
//Tipo e Ano/
//Tipo e preço
//idAutomovel 	nomeModelo 	anoFabricacao 	anoModelo 	preco

//CREATE VIEW modelo_ano_preco AS select idAutomovel,nomeModelo,anoFabricacao,anoModelo,preco,url_foto FROM Automovel JOIN Modelo ON Automovel.Modelo_idModelo=Modelo.idModelo;
   /**
      Retorna os veículos "indexados" pela view modelo_ano_preco por base no 
      nome do modelo e seu ano
   */
   public function porModeloAno($nomeModelo,$anoIni,$anoFim,$limit1,$limit2){
      return $this->link->query("SELECT * FROM ".$this->link->getDB().".modelo_ano_preco WHERE nomeModelo LIKE \"%".$nomeModelo."%\" AND anoFabricacao >=".$anoIni." AND anoFabricacao <= ".$anoFim." LIMIT ".$limit1.",".$limit2);
   }
   /**
      Conta os veículos "indexados" pela view modelo_ano_preco por base no 
      nome do modelo e seu ano
   */
   public function porModeloAnoConta($nomeModelo,$anoIni,$anoFim){
      $ret = $this->link->query("SELECT COUNT(*) AS total FROM ".$this->link->getDB().".modelo_ano_preco WHERE nomeModelo LIKE \"%".$nomeModelo."%\" AND anoFabricacao >=".$anoIni." AND anoFabricacao <=". $anoFim);
      if ($ret){
         foreach($ret as $rt){
            return $rt['total'];
         }
      }else{
         return false;
      }
   }
   /**
      Retorna os veículos "indexados" pela view modelo_ano_preco por base no 
      nome do modelo e seu preço
   */
   public function porModeloPreco($nomeModelo,$precoMin,$precoMax,$limit1,$limit2){
      return $this->link->query("SELECT * FROM ".$this->link->getDB().".modelo_ano_preco WHERE nomeModelo LIKE \"%".$nomeModelo."%\" AND preco>=".$precoMin." AND preco<=".$precoMax." LIMIT ".$limit1.",".$limit2);
   }
   /**
      Conta os veículos "indexados" pela view modelo_ano_preco por base no 
      nome do modelo e seu preço
   */
   public function porModeloPrecoConta($nomeModelo,$precoMin,$precoMax){
      $ret = $this->link->query("SELECT COUNT(*) AS total FROM ".$this->link->getDB().".modelo_ano_preco WHERE nomeModelo LIKE \"%".$nomeModelo."%\" AND preco>=".$precoMin." AND preco<=".$precoMax);
      if ($ret){
         foreach($ret as $rt){
            return $rt['total'];
         }
      }else{
         return false;
      }
   }
      

//Tipo e Ano 
//idTipo 	nomeTipo 	idAutomovel 	nomeModelo 	anoFabricacao 	anoModelo 	preco
//CREATE VIEW tipo_ano_preco AS select idAutomovel,idTipo,nomeModelo,anoFabricacao,anoModelo,preco,url_foto FROM Tipo, Modelo, Automovel WHERE Modelo.idModelo = Automovel.Modelo_idModelo AND Modelo.Tipo_idTipo = Tipo.idTipo 
   /**
      Recupera os veículos "indexados" pela view tipo_ano_preco por base no 
      nome do tipo e seu ano
   */
   public function porTipoAno($idTipo,$anoIni,$anoFim,$limit1,$limit2){
      return $this->link->query("SELECT * FROM ".$this->link->getDB().".tipo_ano_preco WHERE idTipo=".$idTipo." AND anoFabricacao >=".$anoIni." AND anoFabricacao <=". $anoFim." LIMIT ".$limit1.",".$limit2);
   }

   /**
      Conta os veículos "indexados" pela view tipo_ano_preco por base no 
      nome do tipo e seu ano
   */
   public function porTipoAnoConta($idTipo,$anoIni,$anoFim){
      $ret =  $this->link->query("SELECT COUNT(*) AS total FROM ".$this->link->getDB().".tipo_ano_preco WHERE idTipo=".$idTipo." AND anoFabricacao >=".$anoIni." AND anoFabricacao <=". $anoFim);
      if ($ret){
         foreach($ret as $rt){
            return $rt['total'];
         }
      }else{
         return false;
      }

   }

   /**
      Recupera os veículos "indexados" pela view tipo_ano_preco por base no 
      nome do tipo e seu preço
   */
   public function porTipoPreco($idTipo,$precoMin,$precoMax,$limit1,$limit2){
      return($this->link->query("SELECT * FROM ".$this->link->getDb().".tipo_ano_preco WHERE idTipo=".$idTipo." AND preco>=".$precoMin." AND preco<=".$precoMax." LIMIT ".$limit1.",".$limit2));
   }
   
   /**
      Conta os veículos "indexados" pela view tipo_ano_preco por base no 
      nome do tipo e seu preço
   */
   public function porTipoPrecoConta($idTipo,$precoMin,$precoMax){
      $ret = $this->link->query("SELECT COUNT(*) AS total FROM ".$this->link->getDb().".tipo_ano_preco WHERE idTipo=".$idTipo." AND preco>=".$precoMin." AND preco<=".$precoMax);
      if ($ret){
         foreach($ret as $rt){
            return $rt['total'];
         }
      }else{
         return false;
      }
   }

   /**
      Recupera os veículos "indexados" pela view AutomovelCompleto.
      Recebe inúmeros argumentos, monta uma consulta e retorna.
      Se o argumento não for necessário, passar ""
   */
   public function avancada($idModelo,$idMarca,$idCor,$idTipo,$idCombustivel,$quilometragemMin,$quilometragemMax,$precoMin,$precoMax,$anoIni,$anoFim,$portas, $limit1, $limit2){
   $query="SELECT * FROM ".$this->link->getDb().".AutomovelCompleto WHERE 1=1";
   if($idModelo!="")
      $query.=" AND idModelo=".$idModelo."";
   if($idMarca!="")
      $query.=" AND idMarca=".$idMarca."";
   if($idCor!="")
      $query.=" AND idCor=".$idCor."";
   if($idTipo!="")
      $query.=" AND idTipo=".$idTipo."";
   if($idCombustivel!="")
      $query.=" AND idCombustivel=".$idCombustivel."";
   if($quilometragemMin!="")
      $query.=" AND quilometragem>=".$quilometragemMin."";
   if($quilometragemMax!="")
      $query.=" AND quilometragem<=".$quilometragemMax."";
   if($precoMin!="")
      $query.=" AND preco>=".$precoMin."";
   if($precoMax!="")
      $query.=" AND preco<=".$precoMax."";
   if($anoIni!="")
      $query.=" AND anoFabricacao>=".$anoIni."";
   if($anoFim!="")
      $query.=" AND anoFabricacao<=".$anoFim."";
   if($portas!="")
      $query.=" AND portas=".$portas."";
      
   $query.=" LIMIT ".$limit1.",".$limit2;
//      echo $query;
      return($this->link->query($query));
   }
   /**
      Conta os veículos "indexados" pela view AutomovelCompleto.
      Recebe inúmeros argumentos, monta uma consulta e retorna.
      Se o argumento não for necessário, passar ""
   */
   public function avancadaConta($idModelo,$idMarca,$idCor,$idTipo,$idCombustivel,$quilometragemMin,$quilometragemMax,$precoMin,$precoMax,$anoIni,$anoFim,$portas){
   $query="SELECT COUNT(*) AS total FROM ".$this->link->getDb().".AutomovelCompleto WHERE 1=1";
   if($idModelo!="")
      $query.=" AND idModelo=".$idModelo." ";
   if($idMarca!="")
      $query.=" AND idMarca=".$idMarca." ";
   if($idCor!="")
      $query.=" AND idCor=".$idCor." ";
   if($idTipo!="")
      $query.=" AND idTipo=".$idTipo." ";
   if($idCombustivel!="")
      $query.=" AND idCombustivel=".$idCombustivel." ";
   if($quilometragemMin!="")
      $query.=" AND quilometragem>=".$quilometragemMin." ";
   if($quilometragemMax!="")
      $query.=" AND quilometragem<=".$quilometragemMax." ";
   if($precoMin!="")
      $query.=" AND preco>=".$precoMin." ";
   if($precoMax!="")
      $query.=" AND preco<=".$precoMax." ";
   if($anoIni!="")
      $query.=" AND anoFabricacao>=".$anoIni." ";
   if($anoFim!="")
      $query.=" AND anoFabricacao<=".$anoFim." ";
   if($portas!="")
      $query.=" AND portas=".$portas." ";
      
   //echo $query;
      $ret = $this->link->query($query);
   
      if ($ret){
         foreach($ret as $rt){
            return $rt['total'];
         }
      }else{
         return false;
      }
   }
   
   /**
      Recupera certa quantidade de veículos "indexados" pela view AutomovelCompleto
      de maneira "randômica".
      Recebe o número de veículos a serem recuperados
   */
   public function recuperaRand($quantidade){
      return $this->link->query("SELECT * FROM ".$this->link->getDb().".AutomovelCompleto ORDER BY RAND() LIMIT ".$quantidade);
   }

}

?>
